/*
		EditDoor.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.
		Class to match dialog of the same name.	
*/

#include "stdafx.h"
#include "Cbreak.h"
#include "EditDoor.h"
#include "World.h"
#include "Room.h"
#include "utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditDoor dialog

extern World the_world;
extern CCbreakApp theApp;

extern const char *dirs[];

EditDoor::EditDoor(int dir, CWnd* pParent /*=NULL*/)
	: CDialog(EditDoor::IDD, pParent)
{
	Room *lroom;
	int room_vnum= theApp.dlg->current_room;
  lroom = &(the_world.room_list[room_vnum]);
	//{{AFX_DATA_INIT(EditDoor)
	m_door_name = _T("");
	m_door_key = 0;
	m_no_key = FALSE;
	m_door_flag = -1;
	m_edit_direction = _T("");
	m_door_desc = _T("");
	m_door_target = 0;
	//}}AFX_DATA_INIT
  m_edit_direction = iprintf("Room %d: exit %s",room_vnum,dirs[dir]);
	m_door_name = iprintf("%s",lroom->direction_data[dir].keyword.c_str());
	m_door_desc = iprintf("%s",lroom->direction_data[dir].look.c_str());
	if(lroom->direction_data[dir].key_vnum == -1) {
		m_no_key = TRUE;
		key_holder=lroom->direction_data[dir].key_vnum;
	} else {
		m_no_key = FALSE;
		key_holder = 0;
	}
	m_door_key = lroom->direction_data[dir].key_vnum;
	m_door_target = lroom->direction_data[dir].target_room;
	m_door_flag = lroom->direction_data[dir].exit_bits;
  the_dir=dir;

}


void EditDoor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(EditDoor)
	DDX_Text(pDX, IDC_EDIT_DOOR_NAME, m_door_name);
	DDX_Text(pDX, IDC_EDIT_DOOR_KEY, m_door_key);
	DDX_Check(pDX, IDC_EDIT_DOOR_NOKEY, m_no_key);
	DDX_Radio(pDX, IDC_EDIT_DOOR_RAD1, m_door_flag);
	DDX_Text(pDX, IDC_EDIT_DOOR_DIR, m_edit_direction);
	DDX_Text(pDX, IDC_EDIT_DOOR_DESC, m_door_desc);
	DDX_Text(pDX, IDC_EDIT_DOOR_TARGET, m_door_target);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(EditDoor, CDialog)
	//{{AFX_MSG_MAP(EditDoor)
	ON_BN_CLICKED(IDC_EDIT_DOOR_NOKEY, OnEditDoorNokey)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditDoor message handlers

void EditDoor::OnEditDoorNokey() 
{
	if(m_no_key == FALSE) {
		UpdateData(TRUE);
		key_holder = m_door_key;
		m_door_key = -1;
		m_no_key = TRUE;
		GetDlgItem(IDC_EDIT_DOOR_KEY)->EnableWindow(FALSE);
		UpdateData(FALSE);
	} else {
		m_door_key=key_holder;
		GetDlgItem(IDC_EDIT_DOOR_KEY)->EnableWindow(TRUE);
		m_no_key = FALSE;
		UpdateData(FALSE);
  }	
}

BOOL EditDoor::OnInitDialog() 
{
	CDialog::OnInitDialog();

	key_holder=m_door_key;

	if(m_no_key == FALSE) {
		m_no_key = FALSE;
		GetDlgItem(IDC_EDIT_DOOR_KEY)->EnableWindow(TRUE);
		UpdateData(TRUE);
	} else {
		key_holder = m_door_key;
		m_door_key=-1;
		GetDlgItem(IDC_EDIT_DOOR_KEY)->EnableWindow(FALSE);
		m_no_key = TRUE;
		UpdateData(FALSE);
  }	
	UpdateData(FALSE);

	return TRUE;  
}

void EditDoor::OnOK() 
{
	Room *lroom;
	int room_vnum= theApp.dlg->current_room;
  lroom = &(the_world.room_list[room_vnum]);
  
	UpdateData(TRUE);

	lroom->direction_data[the_dir].exit_bits = m_door_flag;
  lroom->direction_data[the_dir].look = m_door_desc;
	lroom->direction_data[the_dir].key_vnum = m_door_key;

	lroom->direction_data[the_dir].target_room = m_door_target;
	lroom->direction_data[the_dir].keyword = m_door_name;

	theApp.dlg->m_redit.LoadRedit();

	CDialog::OnOK();
}
