/*
		medit.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Primary control dialog for the medit window.
*/

#pragma warning(disable:4786)
#include "stdafx.h"
#include "Cbreak.h"
#include "Medit.h"
#include "Mob.h"
#include "World.h"
#include "JumpToMob.h"
#include "NewMob.h"
#include "World.h"
#include "BitvectorSel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Medit property page

IMPLEMENT_DYNCREATE(Medit, CPropertyPage)

Medit::Medit() : CPropertyPage(Medit::IDD)
{
	//{{AFX_DATA_INIT(Medit)
	m_ac = 0;
	m_alias = _T("");
	m_align = 0;
	m_attack_type = -1;
	m_attack_dice = 0;
	m_attack_range = _T("");
	m_attack_size = 0;
	m_cha = 0;
	m_con = 0;
	m_damroll = 0;
	m_detail_desc = _T("");
	m_dex = 0;
	m_sex = -1;
	m_hit_dice = 0;
	m_hit_range = _T("");
	m_hit_size = 0;
	m_hitroll = 0;
	m_int = 0;
	m_level = 0;
	m_long_desc = _T("");
	m_mana_dice = 0;
	m_mana_range = _T("");
	m_mana_size = 0;
	m_move_dice = 0;
	m_move_range = _T("");
	m_move_size = 0;
	m_short_desc = _T("");
	m_str = 0;
	m_wis = 0;
	m_default_pos = -1;
	m_exp = 0;
	m_gold = 0;
	m_load_pos = -1;
	m_mana_bonus = 0;
	m_move_bonus = 0;
	m_hit_bonus = 0;
	m_stradd = 0;
	//}}AFX_DATA_INIT
}

Medit::~Medit()
{
}

void Medit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Medit)
	DDX_Control(pDX, IDC_MOB_SHORTD, e_short_desc);
	DDX_Control(pDX, IDC_MOB_LONGD, e_long_desc);
	DDX_Control(pDX, IDC_MOB_DETD, e_detail_desc);
	DDX_Control(pDX, IDC_MOB_ALIAS, e_alias);
	DDX_Control(pDX, IDC_MOB_NUMBER, m_num);
	DDX_Text(pDX, IDC_MOB_AC, m_ac);
	DDX_Text(pDX, IDC_MOB_ALIAS, m_alias);
	DDX_Text(pDX, IDC_MOB_ALIGNMENT, m_align);
	DDX_CBIndex(pDX, IDC_MOB_ATTACK, m_attack_type);
	DDX_Text(pDX, IDC_MOB_ATTACK_DICE, m_attack_dice);
	DDX_Text(pDX, IDC_MOB_ATTACK_RANGE, m_attack_range);
	DDX_Text(pDX, IDC_MOB_ATTACK_SIZE, m_attack_size);
	DDX_Text(pDX, IDC_MOB_CHA, m_cha);
	DDX_Text(pDX, IDC_MOB_CON, m_con);
	DDX_Text(pDX, IDC_MOB_DAMROLL, m_damroll);
	DDX_Text(pDX, IDC_MOB_DETD, m_detail_desc);
	DDX_Text(pDX, IDC_MOB_DEX, m_dex);
	DDX_CBIndex(pDX, IDC_MOB_GENDER, m_sex);
	DDX_Text(pDX, IDC_MOB_HIT_DICE, m_hit_dice);
	DDX_Text(pDX, IDC_MOB_HIT_RANGE, m_hit_range);
	DDX_Text(pDX, IDC_MOB_HIT_SIZE, m_hit_size);
	DDX_Text(pDX, IDC_MOB_HITROLL, m_hitroll);
	DDX_Text(pDX, IDC_MOB_INT, m_int);
	DDX_Text(pDX, IDC_MOB_LEVEL, m_level);
	DDX_Text(pDX, IDC_MOB_LONGD, m_long_desc);
	DDX_Text(pDX, IDC_MOB_MANA_DICE, m_mana_dice);
	DDX_Text(pDX, IDC_MOB_MANA_RANGE, m_mana_range);
	DDX_Text(pDX, IDC_MOB_MANA_SIZE, m_mana_size);
	DDX_Text(pDX, IDC_MOB_MOVE_DICE, m_move_dice);
	DDX_Text(pDX, IDC_MOB_MOVE_RANGE, m_move_range);
	DDX_Text(pDX, IDC_MOB_MOVE_SIZE, m_move_size);
	DDX_Text(pDX, IDC_MOB_SHORTD, m_short_desc);
	DDX_Text(pDX, IDC_MOB_STR, m_str);
	DDX_Text(pDX, IDC_MOB_WIS, m_wis);
	DDX_CBIndex(pDX, IDC_MOB_DEFAULT_POS, m_default_pos);
	DDX_Text(pDX, IDC_MOB_EXPERIENCE, m_exp);
	DDX_Text(pDX, IDC_MOB_GOLD, m_gold);
	DDX_CBIndex(pDX, IDC_MOB_LOAD_POS, m_load_pos);
	DDX_Text(pDX, IDC_MOB_MANA_BONUS, m_mana_bonus);
	DDX_Text(pDX, IDC_MOB_MOVE_BONUS, m_move_bonus);
	DDX_Text(pDX, IDC_MOB_HIT_BONUS, m_hit_bonus);
	DDX_Text(pDX, IDC_MOB_STRADD, m_stradd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Medit, CPropertyPage)
	//{{AFX_MSG_MAP(Medit)
	ON_BN_CLICKED(IDC_MOB_NUMBER, OnMobNumber)
	ON_BN_CLICKED(IDC_PREV_MOB, OnPrevMob)
	ON_BN_CLICKED(IDC_NEXT_MOB, OnNextMob)
	ON_BN_CLICKED(IDC_PREV_MOBZ, OnPrevMobz)
	ON_BN_CLICKED(IDC_NEXT_MOBZ, OnNextMobz)
	ON_EN_CHANGE(IDC_MOB_ALIAS, OnChangeMobAlias)
	ON_EN_CHANGE(IDC_MOB_SHORTD, OnChangeMobShortd)
	ON_EN_CHANGE(IDC_MOB_LONGD, OnChangeMobLongd)
	ON_EN_CHANGE(IDC_MOB_DETD, OnChangeMobDetd)
	ON_EN_CHANGE(IDC_MOB_HIT_DICE, OnChangeMobHitDice)
	ON_EN_CHANGE(IDC_MOB_HIT_SIZE, OnChangeMobHitSize)
	ON_EN_CHANGE(IDC_MOB_HIT_BONUS, OnChangeMobHitBonus)
	ON_EN_CHANGE(IDC_MOB_GOLD, OnChangeMobGold)
	ON_EN_CHANGE(IDC_MOB_EXPERIENCE, OnChangeMobExperience)
	ON_EN_CHANGE(IDC_MOB_ALIGNMENT, OnChangeMobAlignment)
	ON_EN_CHANGE(IDC_MOB_STR, OnChangeMobStr)
	ON_EN_CHANGE(IDC_MOB_INT, OnChangeMobInt)
	ON_EN_CHANGE(IDC_MOB_WIS, OnChangeMobWis)
	ON_EN_CHANGE(IDC_MOB_DEX, OnChangeMobDex)
	ON_EN_CHANGE(IDC_MOB_CHA, OnChangeMobCha)
	ON_EN_CHANGE(IDC_MOB_CON, OnChangeMobCon)
	ON_EN_CHANGE(IDC_MOB_STRADD, OnChangeMobStradd)
	ON_CBN_SELCHANGE(IDC_MOB_GENDER, OnEditchangeMobGender)
	ON_CBN_SELCHANGE(IDC_MOB_LOAD_POS, OnEditchangeMobLoadPos)
	ON_CBN_SELCHANGE(IDC_MOB_DEFAULT_POS, OnEditchangeMobDefaultPos)
	ON_EN_CHANGE(IDC_MOB_ATTACK_SIZE, OnChangeMobAttackSize)
	ON_EN_CHANGE(IDC_MOB_ATTACK_DICE, OnChangeMobAttackDice)
	ON_CBN_SELCHANGE(IDC_MOB_ATTACK, OnEditchangeMobAttack)
	ON_EN_CHANGE(IDC_MOB_HITROLL, OnChangeMobHitroll)
	ON_EN_CHANGE(IDC_MOB_LEVEL, OnChangeMobLevel)
	ON_EN_CHANGE(IDC_MOB_DAMROLL, OnChangeMobDamroll)
	ON_EN_CHANGE(IDC_MOB_AC, OnChangeMobAc)
	ON_BN_CLICKED(IDC_MOB_NPCF, OnMobNpcf)
	ON_BN_CLICKED(IDC_MOB_AFF, OnMobAff)
	ON_BN_CLICKED(IDC_MOB_SAVEZONE, OnMobSavezone)
	ON_BN_CLICKED(IDC_MOB_NEW, OnMobNew)
	ON_BN_CLICKED(IDC_MOB_DELETE, OnMobDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Medit message handlers

extern CDirDialog ourlib;
extern CCbreakApp theApp;
extern World the_world;

BOOL Medit::OnSetActive() 
{


	if(theApp.dlg->current_mob >= 0) {
		LoadMedit();
	}
	this->UpdateData();
	return CPropertyPage::OnSetActive();	
}

int Medit::LoadMedit()
{
  int mob_vnum;
	Mob *lmob;

	if(!are_there_zones()) {
    disable_medit(-1);
	} else if (the_world.mob_list.empty()) {
		disable_medit(0);
	} else {
		disable_medit(1);
	}

	mob_vnum= theApp.dlg->current_mob;
  lmob = &(the_world.mob_list[mob_vnum]);

	m_alias = lmob->alias.c_str();
  m_num.SetWindowText(iprintf("%d",lmob->number));
  m_short_desc = lmob->sdesc.c_str();
	m_long_desc = lmob->ldesc.c_str();
	m_detail_desc = lmob->ddesc.c_str();
	m_ac = lmob->ac;
	m_align = lmob->alignment;
	m_attack_dice = lmob->attack_dice;
	m_attack_size = lmob->attack_size;

	m_attack_range = iprintf("%d - %d",m_attack_dice + m_damroll, 
			(m_attack_dice * m_attack_size)+m_damroll);
	m_attack_type=0;
  m_str = lmob->stats[STAT_STR];
  m_stradd = lmob->stats[STAT_STRADD];
  m_con = lmob->stats[STAT_CON];
  m_dex = lmob->stats[STAT_DEX];
  m_int = lmob->stats[STAT_INT];
  m_wis = lmob->stats[STAT_WIS];
  m_cha = lmob->stats[STAT_CHA];

	m_damroll = lmob->attack_bonus;
  m_default_pos = lmob->default_pos;
	m_exp = lmob->experience;
	m_gold = lmob->gold;

	m_hit_bonus = lmob->hit_bonus;
	m_hit_dice = lmob->hit_dice;
	m_hit_size = lmob->hit_size;

	m_hit_range = iprintf("%d - %d",m_hit_dice + m_hit_bonus, 
			(m_hit_dice * m_hit_size)+m_hit_bonus);
	m_hitroll = lmob->thac0;

	m_load_pos = lmob->load_pos;
	m_level = lmob->level;
	m_mana_bonus = 20;
	m_mana_dice = 0;
	m_mana_size = 0;
	m_mana_range = iprintf("%d - %d",m_mana_dice + m_mana_bonus, 
			(m_mana_dice * m_mana_size)+m_mana_bonus);
	m_move_bonus = 20;
	m_move_dice = 0;
	m_move_size = 0;
	m_move_range = iprintf("%d - %d",m_move_dice + m_move_bonus, 
			(m_move_dice * m_move_size)+m_move_bonus);
  m_sex = lmob->gender;
	
	this->UpdateData(FALSE);
  return TRUE;
}

void Medit::OnMobNumber() 
{
	JumpToMob jumper;
	jumper.DoModal();
	
}


void Medit::OnNextMob() 
{
	extern CCbreakApp theApp;
  int mob_num = theApp.dlg->current_mob;
  map<int, Mob>::const_iterator ri;

	ri=the_world.mob_list.find(mob_num);
	if(ri == the_world.mob_list.end()) {
		/* this is a serious problem. indicates the current mob DNE! */
		error("Uh. The current mob doesn't exist?");
	} 
	ri++;
	if(ri == the_world.mob_list.end()) {
		ri=the_world.mob_list.begin();
  }
	theApp.dlg->current_mob = ri->first;

	LoadMedit();
}

void Medit::OnPrevMob() 
{
	extern CCbreakApp theApp;
  int mob_num = theApp.dlg->current_mob;
  map<int, Mob>::const_iterator ri;

	ri=the_world.mob_list.find(mob_num);
	if(ri == the_world.mob_list.end()) {
		/* this is a serious problem. indicates the current mob DNE! */
		error("Uh. The current mob doesn't exist?");
	} 
	if(ri == the_world.mob_list.begin()) {
		ri= the_world.mob_list.end();
	}
	ri--;
	if(ri == the_world.mob_list.end()) {
		ri=the_world.mob_list.begin();
  }
	theApp.dlg->current_mob = ri->first;

	LoadMedit();
	
}

void Medit::OnNextMobz() 
{
	extern CCbreakApp theApp;
  int mob_num = theApp.dlg->current_mob;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Mob>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.mob_list[mob_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.mob_list.find(mob_num);ri != the_world.mob_list.end();ri++) {
  	if(the_world.mob_list[ri->first].zone != the_world.mob_list[mob_num].zone) {
      break;
		}
	}
	if(ri == the_world.mob_list.end()) {
		ri=the_world.mob_list.begin();
	}

	theApp.dlg->current_mob = ri->first;
	this->LoadMedit();	
}

void Medit::OnPrevMobz() 
{
	extern CCbreakApp theApp;
  int mob_num = theApp.dlg->current_mob;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Mob>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.mob_list[mob_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.mob_list.find(mob_num);ri != the_world.mob_list.begin();ri--) {
  	if(the_world.mob_list[ri->first].zone != the_world.mob_list[mob_num].zone) {
      break;
		}
	}

	if(ri == the_world.mob_list.begin() && the_world.mob_list[ri->first].zone ==
			the_world.mob_list[mob_num].zone) {
		ri=the_world.mob_list.end();
		ri--;
	}

	theApp.dlg->current_mob = ri->first;
	this->LoadMedit();	
}

void Medit::OnChangeMobAlias() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->alias= m_alias;
}

void Medit::OnChangeMobShortd() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->sdesc= m_short_desc;
	
}

void Medit::OnChangeMobLongd() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->ldesc= m_long_desc;
	
}

void Medit::OnChangeMobDetd() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->ddesc= m_detail_desc;
	
}

void Medit::OnChangeMobHitDice() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->hit_dice= m_hit_dice;
	

	m_hit_range = iprintf("%d - %d",m_hit_dice + m_hit_bonus, 
			(m_hit_dice * m_hit_size)+m_hit_bonus);
}

void Medit::OnChangeMobHitSize() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->hit_size= m_hit_size;
	
	m_hit_range = iprintf("%d - %d",m_hit_dice + m_hit_bonus, 
			(m_hit_dice * m_hit_size)+m_hit_bonus);
}

void Medit::OnChangeMobHitBonus() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->hit_bonus= m_hit_bonus;
	
}

void Medit::OnChangeMobGold() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->gold= m_gold;
	
}

void Medit::OnChangeMobExperience() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->experience= m_exp;
	
}

void Medit::OnChangeMobAlignment() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->alignment= m_align;
	
}

void Medit::OnChangeMobStr() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->stats[STAT_STR]= m_str;
	
}

void Medit::OnChangeMobInt() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->stats[STAT_INT]= m_int;
}

void Medit::OnChangeMobWis() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->stats[STAT_INT]= m_int;
	
}

void Medit::OnChangeMobDex() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->stats[STAT_DEX]= m_dex;
	
}

void Medit::OnChangeMobCha() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->stats[STAT_CHA]= m_cha;
}

void Medit::OnChangeMobCon() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->stats[STAT_CON]= m_con;
}

void Medit::OnChangeMobStradd() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->stats[STAT_STRADD]= m_stradd;
}

void Medit::OnEditchangeMobGender() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->gender = m_sex;
}

void Medit::OnEditchangeMobLoadPos() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->load_pos = m_load_pos;
	
}

void Medit::OnEditchangeMobDefaultPos() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->default_pos = m_default_pos;	
}

void Medit::OnChangeMobAttackSize() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->attack_size = m_attack_size;	
	
}

void Medit::OnChangeMobAttackDice() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->attack_dice = m_attack_dice;	
		m_attack_range = iprintf("%d - %d",m_attack_dice + m_damroll, 
			(m_attack_dice * m_attack_size)+m_damroll);
}

void Medit::OnEditchangeMobAttack() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->attack_type = m_attack_type;		
		m_attack_range = iprintf("%d - %d",m_attack_dice + m_damroll, 
			(m_attack_dice * m_attack_size)+m_damroll);
}

void Medit::OnChangeMobHitroll() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->thac0 =m_hitroll;	
}

void Medit::OnChangeMobLevel() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->level = m_level;		
}

void Medit::OnChangeMobDamroll() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->attack_bonus = m_damroll;	
}

void Medit::OnChangeMobAc() 
{
	Mob *lmob;

	int mob_vnum= theApp.dlg->current_mob;
  UpdateData(TRUE);
  lmob = &(the_world.mob_list[mob_vnum]);

	lmob->ac = m_ac;	
}

void Medit::OnMobNpcf() 
{
  BitvectorSel mc(the_world.mob_list[theApp.dlg->current_mob].action,"Mob Act Flags");
  mc.DoModal();
  the_world.mob_list[theApp.dlg->current_mob].action=mc.total;
}

void Medit::OnMobAff() 
{
  BitvectorSel mc(the_world.mob_list[theApp.dlg->current_mob].affect,"Affect Flags");
  mc.DoModal();
  the_world.mob_list[theApp.dlg->current_mob].affect=mc.total;
}

void Medit::OnMobSavezone() 
{
  int zone = the_world.mob_list[theApp.dlg->current_mob].zone;
  the_world.save_zone(zone);
    AfxMessageBox("The zone is saved.\n",MB_OK);
	
}

void Medit::OnMobNew() 
{
  NewMob nm;
  nm.DoModal();	
}

void Medit::OnMobDelete() 
{
  int delmob = theApp.dlg->current_mob;

  if(AfxMessageBox("Are you sure you wish to delete this Mob?",
	  MB_YESNO | MB_APPLMODAL | MB_ICONQUESTION) == IDYES) {
    OnNextMob();
    the_world.mob_list.erase(delmob);
  }		
}

/* -1 = complete disable
    0 = all but save & create
	1 = normal working paramaters
*/
void Medit::disable_medit(int all)
{
  int i;

	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
		if(GetDlgItem(i)) {
      GetDlgItem(i)->EnableWindow(FALSE);
		}
	}
	if(all == -1) {
		return;
	}
  GetDlgItem(IDC_MOB_SAVEZONE)->EnableWindow(TRUE);
  GetDlgItem(IDC_MOB_NEW)->EnableWindow(TRUE);

	if(all == 1) {
  	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
	  	if(GetDlgItem(i)) {
        GetDlgItem(i)->EnableWindow(TRUE);
			}
		}
	}

}

BOOL Medit::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	if(!are_there_zones()) {
    disable_medit(-1);
	} else if (the_world.mob_list.empty()) {
		disable_medit(0);
	} else {
		disable_medit(1);
  }	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
